//

#include "iodefine.h"
#include "ignition.h"
#include "rotation_speed.h"
#include "ecu_init.h"
#include "crank.h"
#include "ign_map.h"

volatile unsigned short PROCTIME;
volatile unsigned short IGN1_BUFF,IGN2_BUFF;

void ignmap_init(void)
{
	unsigned char a,b;
	
	for(a=0;a<16;a++)
	{
		for(b=0;b<25;b++)
		{
			IGN_MAP[a][b]=IGN_MAP_INITIAL[a][b];	// ˕␳}bv
		}
	}
}

extern void ignition_init(void)
{
	ignmap_init();
	
	// IGN1 PE0
	// IGN2 PE2
	PFC.PECRL1.BIT.PE0MD=0;		// PE0PE0o
	PFC.PECRL1.BIT.PE2MD=0;		// PE2PE2o
	IGN1_PIN=1;
	IGN2_PIN=1;
	PFC.PEIORL.BIT.B0=1;	// TIOC0A ͏o
	PFC.PEIORL.BIT.B2=1;	// TIOC0C ͏o
	
	INTC.IPRJ.BIT._CMT0=5;	// CMT RyA}b`荞ݗD惌x
	INTC.IPRJ.BIT._CMT1=5;	// CMT RyA}b`荞ݗD惌x

	STB.CR4.BIT._CMT=0;		// W[Xgbv[h
	CMT.CMSTR.BIT.STR0=0;	// ^C}[~
	CMT.CMSTR.BIT.STR1=0;	// ^C}[~
	CMT0.CMCSR.BIT.CKS=1;	// ̓NbN /32
	CMT1.CMCSR.BIT.CKS=1;	// ̓NbN /32
	CMT0.CMCSR.BIT.CMIE=1;	// RyA}b`荞݋
	CMT1.CMCSR.BIT.CMIE=1;	// RyA}b`荞݋
	// 32*1/24000000*65535 87.38msŃI[o[t[
	// 500rpm NN1] 1/(500/60) 120ms NNAOZT[Ne̊Ԋu 1/(500/60)/2 60ms
}

#pragma inline(getign)
static unsigned char getign(unsigned short rpm, unsigned char air)
{
	unsigned char index_a1,index_a2,index_r1,index_r2;
	int a,b,c,d;

	air=255-air;	// e[u₷邽ߋCʂ̕тtɂĂ
	if(rpm>8000) rpm=8000;	// ͈͂̃`FbN

	if(air>10)
	{
		index_a1=air/10-1;
		if(index_a1==24)index_a2=index_a1;
		else index_a2=index_a1+1;
	}
	else
	{
		index_a1=0;
		index_a2=0;
	}
	
	if(rpm>500)
	{
		index_r1=rpm/500-1;
		if(index_r1==15)index_r2=index_r1;
		else index_r2=index_r1+1;
	}
	else
	{
		index_r1=0;
		index_r2=0;
	}
	
	a=IGN_MAP[index_r1][index_a1];
	b=IGN_MAP[index_r1][index_a2];
	a=a+((b-a)*(air%10)/10);	// 2_Ԃ̕⊮

	c=IGN_MAP[index_r2][index_a1];
	d=IGN_MAP[index_r2][index_a2];
	b=c+((d-c)*(air%10)/10);	// 2_Ԃ̕⊮
	
	a=a+((b-a)*(rpm%500)/500);	// 2_Ԃ̕⊮

	if(IN_TEN==0)
	{
		a=10;			// TEN[qLoieXg[hj_ΎBTDC10xŒ
	}
	
	MONIGN=a;	// j^p
	
	return a;
}

// CMT0 RyA}b`荞
void interrupt_CMT0(void)
{
	unsigned int temp;
	
	if(IGN1_PIN==1)	// ڂ̃RyA}b`
	{
		IGN1_PIN=0;
		CMT0.CMCOR=IGN1_BUFF;
	}
	else			// ڂ̃RyA}b`
	{
		IGN1_PIN=1;
		CMT.CMSTR.BIT.STR0=0;	// ^C}[~
	}
	
//	temp=CMT0.CMCSR.WORD;
//	CMT0.CMCSR.BIT.CMF=0;	// 荞݃tONA
//	if(CMT0.CMCSR.BIT.CMF==1) CMT0.CMCSR.BIT.CMF=0;	// 荞݃tONA
//	temp=CMT0.CMCSR.BIT.CMF=0;	// _~[[h
	// 荞݃tONA
	while(CMT0.CMCSR.BIT.CMF==1)CMT0.CMCSR.BIT.CMF=0;
}

// CMT1 RyA}b`荞
void interrupt_CMT1(void)
{
	unsigned int temp;

	//set_imask(15);	// 荞݋֎~
	
	if(IGN2_PIN==1)	// ڂ̃RyA}b`
	{
		IGN2_PIN=0;
		CMT1.CMCOR=IGN1_BUFF;
	}
	else			// ڂ̃RyA}b`
	{
		IGN2_PIN=1;
		CMT.CMSTR.BIT.STR1=0;	// ^C}[~
	}
	
//	temp=CMT1.CMCSR.WORD;
//	CMT1.CMCSR.BIT.CMF=0;	// 荞݃tONA
//	if(CMT1.CMCSR.BIT.CMF==1) CMT1.CMCSR.BIT.CMF=0;	// 荞݃tONA
//	temp=CMT1.CMCSR.BIT.CMF;
	// 荞݃tONA
	while(CMT1.CMCSR.BIT.CMF==1) CMT1.CMCSR.BIT.CMF=0;
}

void ignition_pinreset(void)
{
	CMT.CMSTR.BIT.STR0=0;	// ^C}[~
	CMT.CMSTR.BIT.STR1=0;	// ^C}[~
	IGN1_PIN=1;
	IGN2_PIN=1;
}

// n[hNeオ
#pragma inline(start_up)
void start_up(void)
{
	CMT.CMSTR.BIT.STR0=0;	// ^C}[~
	CMT.CMSTR.BIT.STR1=0;	// ^C}[~

	// Neオ
	if(CRANK_G==0) IGN1_PIN=0;
	if(CRANK_G==1) IGN2_PIN=0;

}

// n[hNe
#pragma inline(start)
static void start(void)
{
	CMT.CMSTR.BIT.STR0=0;	// ^C}[~
	CMT.CMSTR.BIT.STR1=0;	// ^C}[~

	// Neオ
	//if((Ne_pin==1) && (CRANK_G==1)) IGN1_PIN=0;
	//if((Ne_pin==1) && (CRANK_G==0)) IGN2_PIN=0;

	// Ne
	/*if(Ne_pin==0)
	{
		IGN1_PIN=1;
		IGN2_PIN=1;
	}*/
	IGN1_PIN=1;
	IGN2_PIN=1;
	
	MONIGN=10;
}

#pragma inline(normal)
static void normal(void)
{
	unsigned short a,b,c,dwell;
// NN]鎞=60/RPMb
// NN1x鎞=60/RPM/360
// ^C}[1JEg=64/IOCLKb
// NN1xJE^l=(60/RPM/360)/(64/IOCLK)
// =(60/RPM/360)/(64/IOCLK)
// =60/RPM/360/64/IOCLK
// =60/360/64/RPM/IOCLK
// =60/360/64*IOCLK/RPM
// =IOCLK/RPM*60/360/64
// =IOCLK*60/360/64/RPM
// =IOCLK*60/(360*64)/RPM
// =IOCLK/((360*64)/60)/RPM
// =IOCLK/((360*64)/60)/RPM
// =IOCLK/384/RPM /64̏ꍇ

// =IOCLK/192/RPM /32̏ꍇ	400RPM炢܂ŃI[o[t[Ȃ
// =IOCLK/768/RPM /128̏ꍇ

// =((60/360)*IOCLK)/(RPM*64)
// =((60*IOCLK)/(360*RPM*64)
// =(60*IOCLK)/(23040*RPM)
// =(IOCLK)/(384*RPM)
// =IOCLK/384/RPM

//	NN1xJE^l
//	 30/RPM/180/((1/IOCLK)*64)
//	=1000000000*30/RPM/180/(1000000000*64/IOCLK)
//	=1000000000/RPM/6/(1000000000*64/IOCLK)
//	=1000000000/64/RPM/6/(1000000000/IOCLK)
//	=1000000000/64/6/RPM/(1000000000/IOCLK)
//	=IOCLK*1000000000/64/6/(RPM*1000000000)
//	=IOCLK/64/6/RPM
//	=IOCLK/RPM/64/6
//	=IOCLK/RPM/384

//	NN190xJE^liNe̗肩190xŏ㎀_(BTDC 0)j
//	190*IOCLK/RPM/384

//	hG^C
//	JEgl=0.003s/(1*64/IOCLK)/10
//	DWELL/(1*64*1000/IOCLK)/10
//	DWELL/(64000/IOCLK)/10
//	DWELL*(IOCLK/64000)/10
//	IOCLK/64000*DWELL/10
//	IOCLK/640000*DWELL
//	IOCLK*DWELL/640000

	//dwell=IOCLK*DWELL/640000;
	//dwell=IOCLK/640000*DWELL;	// ̂ق萔RpCɌvZĖߍ܂邩y 3.2ms1200
	dwell=IOCLK/320000*DWELL;

	c=getign(RPM,(AIR>>8)); // _΃}bv_Ύǂݏo
	
	// _Ύ
	//IOCLK/RPM/384;	// NN1xJE^l
	//(IOCLK/RPM*(190-10)/384);	// BTDC10̏ꍇ
	//b=IOCLK/RPM*(190-c)/384;	// _΂܂ł̑҂ԂvZ
	//b=(int)(IOCLK*60/360/64/RPM)*(190-c);	// _΂܂ł̑҂ԂvZ
	//b=(int)((IOCLK*60/360/64)*(190-c)/RPM);	// _΂܂ł̑҂ԂvZ

	// _΂܂ł̑҂ԂvZ
	//b=(IOCLK/384)*(190-c)/RPM;	// /64
	b=(IOCLK/192)*(190-c)/RPM;	// /32
	//b=b-43;		// e[u̓ǂݏovZɂԕ(43)Ă
	b=b-116;		// NeM̐ϕHł̒xƏɊ|ԕ(43)Ă
	//b=b-(MTU20.TCNT-PROCTIME);	// e[u̓ǂݏovZɂԕĂi^C}[őlj

	// a=RCʓdJn܂ł̑҂
	if((dwell+50)>b)
	{
		a=50;	// hG^C_ΐM̎RZ
		dwell=b-a;
	}
	else
	{
		a=b-dwell;	// ʏ펞
	}

	switch(CYLINDERS)
	{
		case 1:
		case 3:
			IGN2_PIN=1;
			//CMT.CMSTR.BIT.STR1=0;	// ^C}[~
			//CMT1.CMCNT=0;
			CMT1.CMCOR=a;
			IGN2_BUFF=dwell;
			CMT.CMSTR.BIT.STR1=1;	// ^C}[X^[g
			break;
		
		case 2:
		case 4:
			IGN1_PIN=1;
			//CMT.CMSTR.BIT.STR0=0;	// ^C}[~
			//CMT0.CMCNT=0;
			CMT0.CMCOR=a;
			IGN1_BUFF=dwell;
			CMT.CMSTR.BIT.STR0=1;	// ^C}[X^[g
			break;
	}
}

// ʏ펞Ne̗ŌĂ΂
// ]in[hj̎Ne̗GbWŌĂ΂
#pragma inline(ignition)
void ignition(void)
{
	if(RPM<START_RPM)
	{
		//if(RPM!=0) start();	// ]START_RPMȉn[h 0RPMȂ牽Ȃ
		start();
	}
	else normal();
}

